# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

# dirac::CodeBlock Class Reference

Class for encapsulating metadata concerning a block of coefficients in a subband.

`#include <wavelet_utils.h>`

List of all members.

## Public Member Functions

- CodeBlock ()
    Constructor.
- CodeBlock (const int xstart, const int ystart, const int xend, const int yend)
    Constructor.
- int Xstart () const
    Returns the horizontal start of the block.
- int Ystart () const
    Returns the vertical start of the block.
- int Xend () const
    Returns one past the last coefficient coord, horizontally.
- int Yend () const
    Returns one past the last coefficient coord, vertically.
- int Xl () const
    Returns the width of the code block.
- int Yl () const
    Returns the height of the code block.
- int QIndex () const
    Returns the quantisation index associated to the code block.
- float Wt () const
    Returns the weight associated to the code block.
- bool Skipped () const
    Returns true if the code-block is skipped, false if not.
- void SetQIndex (const int qindex)
    Sets the quantisation index.
- void SetSkip (bool skip)
    Sets whether the code block is skipped or not.

## Private Member Functions

- void Init (const int xstart, const int ystart, const int xend, const int yend)
    Initialise the code block.
- void SetWt (const float w)
    Sets the perceptual weight (can only be done by friend class, eg Subband.

## Private Attributes

- int m_xstart
- int m_ystart
- int m_xend
- int m_yend
- int m_xl
- int m_yl
- int m_qindex
- float m_wt
- bool m_skipped

## Friends

- class Subband

## Constructor & Destructor Documentation

dirac::CodeBlock::CodeBlock | ( |  | ) |

dirac::CodeBlock::CodeBlock | ( | const int | xstart,
|  | const int | ystart,
|  | const int | xend,
|  | const int | yend |
| ) |  |  |

## Member Function Documentation

int dirac::CodeBlock::Xstart | ( |  | ) | const`[inline]`

References m_xstart.

int dirac::CodeBlock::Ystart | ( |  | ) | const`[inline]`

References m_ystart.

int dirac::CodeBlock::Xend | ( |  | ) | const`[inline]`

References m_xend.

int dirac::CodeBlock::Yend | ( |  | ) | const`[inline]`

References m_yend.

int dirac::CodeBlock::Xl | ( |  | ) | const`[inline]`

References m_xl.

int dirac::CodeBlock::Yl | ( |  | ) | const`[inline]`

References m_yl.

int dirac::CodeBlock::QIndex | ( |  | ) | const`[inline]`

References m_qindex.

float dirac::CodeBlock::Wt | ( |  | ) | const`[inline]`

References m_wt.

bool dirac::CodeBlock::Skipped | ( |  | ) | const`[inline]`

References m_skipped.

void dirac::CodeBlock::SetQIndex | ( | const int | qindex | ) | `[inline]`

References m_qindex.

void dirac::CodeBlock::SetSkip | ( | bool | skip | ) | `[inline]`

References m_skipped.

void dirac::CodeBlock::Init | ( | const int | xstart,
|  | const int | ystart,
|  | const int | xend,
|  | const int | yend |
| ) |  |  | `[private]`

void dirac::CodeBlock::SetWt | ( | const float | w | ) | `[inline, private]`

References m_wt.

## Friends And Related Function Documentation

friend class Subband `[friend]`

## Member Data Documentation

int dirac::CodeBlock::m_xstart `[private]`

Referenced by Xstart().

int dirac::CodeBlock::m_ystart `[private]`

Referenced by Ystart().

int dirac::CodeBlock::m_xend `[private]`

Referenced by Xend().

int dirac::CodeBlock::m_yend `[private]`

Referenced by Yend().

int dirac::CodeBlock::m_xl `[private]`

Referenced by Xl().

int dirac::CodeBlock::m_yl `[private]`

Referenced by Yl().

int dirac::CodeBlock::m_qindex `[private]`

Referenced by QIndex(), and SetQIndex().

float dirac::CodeBlock::m_wt `[private]`

Referenced by SetWt(), and Wt().

bool dirac::CodeBlock::m_skipped `[private]`

Referenced by SetSkip(), and Skipped().

The documentation for this class was generated from the following file:

- wavelet_utils.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.